'-------------------------------------------------------------------------------
' Demo the ProgressBar
' Author: d_homans@yahoo.com.au
' 22 March 2012
' FreeBasic code generated by RapidFRM v1.58b
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"

InitCommonControls()

#INCLUDE "win/RQInclude.bi"

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QTIMER Timer1
DIM SHARED AS QTIMER PTR lpTimer1 = @Timer1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QPROGRESSBAR PBar
DIM SHARED AS QPROGRESSBAR PTR lpBar = @PBar

'-------------------------------------------------------------------------------
' Forward declarations for component events
'-------------------------------------------------------------------------------
DECLARE SUB DoTimer(Sender AS QTIMER)
DECLARE SUB DoTest(Sender AS QBUTTON)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Caption = "ProgressBar Test"

    lpTimer1->ObjIndex = 1
    lpTimer1->Interval = 100
    lpTimer1->OnTimer = CAST(ANY PTR, @DoTimer)

    lpButn1->ObjIndex = 2
    lpButn1->Left = 100
    lpButn1->Top = 110
    lpButn1->Caption = "Test Me"
    lpButn1->Parent = Form1.Handle
    lpButn1->OnClick = CAST(ANY PTR, @DoTest)

    lpBar->objIndex = 3
    lpBar->Left = 0: lpBar->Top = lpForm1->ClientHeight-10
    lpBar->Width = lpForm1->ClientWidth: lpBar->Height = 10
    lpBar->Min = 1: lpBar->Max = 100
    lpBar->ForeColor = &h7f00: lpBar->BackColor = &hdfffdf
    lpBar->Visible = False
END SUB

'-------------------------------------------------------------------------------
' Load components
'-------------------------------------------------------------------------------
SUB LoadComponents
    SendMessage(Application.hMainForm, WM_LOAD_COMPONENTS, 0, 0)
END SUB


'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB AddChildObjects
DIM AS UINT StdStyle, ExtStyle
DIM AS string ObjCaption

    lpTimer1->Parent=lpForm1->Handle
    SetTimer(lpForm1->Handle, lpTimer1->ObjIndex, lpTimer1->Interval, 0)

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    lpButn1->Parent=lpForm1->Handle
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle += WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpBar->Parent=lpForm1->Handle
    lpBar->Handle=CreateWindowEx(0, PROGRESS_CLASS, "", WS_CHILD, _
                                    lpBar->Left, lpBar->Top, lpBar->Width, lpBar->Height, _
                                                     lpForm1->Handle, lpBar->ObjIndex, 0, 0)
    lpBar->PostConfig()
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers

    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
    lpTimer1->Enabled=False
    KillTimer(lpForm1->Handle, lpTimer1->ObjIndex)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)

    Application.hWndTTip=CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, "", _
                                    WS_POPUP OR TTS_NOPREFIX OR TTS_ALWAYSTIP, _
                   CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
                                                                Parent, 0, 0, 0)
    SetWindowPos(Application.hWndTTip, HWND_TOPMOST, 0, 0, 0, 0, _
                                      SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt
DIM AS integer ShowIt=False

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                    ShowIt=True
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                    ShowIt=True
                END IF
        END SELECT
        IF (ShowIt=False) AND (Application.hWndTTip <> 0) THEN
            DestroyWindow(Application.hWndTTip)
            Application.hWndTTip=0
        END IF
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------
SUB CheckWmCommandMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

    SELECT CASE LOWORD(wParam)
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
    END SELECT
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers

        CASE lpTimer1->ObjIndex
            IF lpTimer1->OnTimer>0 THEN lpTimer1->OnTimer(lpTimer1)

    END SELECT
END SUB

SUB CheckWmNotifyMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB


SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB


SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB


FUNCTION WndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    
    SELECT CASE wMsg
        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(hWnd, wMsg, wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_NOTIFY
            CheckWmNotifyMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->OnMouseMove>0 THEN lpForm1->OnMouseMove(LOWORD(lParam), _
                                                            HIWORD(lParam), 0, lpForm1)
        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_CREATE

        CASE WM_LOAD_COMPONENTS
            AddChildObjects
            InitSystemTimers(hWnd)

        CASE WM_CLOSE
            DIM AS integer Action=1                                      ' Default Action is quit
            IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
            IF Action=0 THEN RETURN 0                                    ' user can change default action

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' WndProc hooks for additional components
'-------------------------------------------------------------------------------
'
' ***Add additional WndProcs as required***
'

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS MSG wMsg
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @WndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = Cast(HBRUSH, COLOR_WINDOW)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    IF RegisterClassEx(@wc) = 0 THEN
        ShowMessage("Register class error")
        RETURN 0
    END IF

    lpForm1->Parent = 0
    lpForm1->Handle = CreateWindowEx(0, "RQClass", lpForm1->Caption, _
                    WS_OVERLAPPEDWINDOW, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, hInst, 0)
    Application.hMainForm = lpForm1->Handle

    ' Load remainder of components
    ConfigureComponents()
    LoadComponents()

    ' You may wish to delete the following line
    lpForm1->Center

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)
    ShowWindow(lpForm1->Handle, SW_SHOW)

    HookTheMouse()
'
'   The following loop is the equivalent of a "Form.ShowModal"
'
    WHILE GetMessage(@wMsg, NULL, 0, 0) <> FALSE
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
    WEND

    UnHookTheMouse()

    RETURN wMsg.wParam
END FUNCTION
'
' Main Entry Point
'
END WinMain(Application.hInstance, NULL, Command(), SW_NORMAL)

'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
SUB DoTimer(Sender AS QTIMER)
    IF lpBar->Visible = False THEN EXIT SUB
    IF lpBar->Position < lpBar->Max THEN
        lpBar->Position = lpBar->Position + 1
        IF lpBar->Position = lpBar->Max THEN
            lpBar->Visible = False
            Application.Terminate
        END IF
    END IF
END SUB

SUB DoTest(Sender AS QBUTTON)
    lpBar->Position = 1
    lpBar->Visible = True
END SUB

